#include<bits/stdc++.h>
using namespace std;
#define ll long long
#define pii pair<int, int>
#define ld double
#define all(a) (a).begin(), (a).end()

#define int long long

const int inf = 1e9 + 7;

int n;
vector<int> a;
int k;

double TL = 1.98;

bool isTimeLimit() {
    static int cnt = 0;
    if (cnt % 32 == 0) {
        if (clock() > TL * CLOCKS_PER_SEC) return true;
    }
    ++cnt;
    return false;
}

double solve() {
    if (k == 1) return 1;
    if (n == 1) {
        return (ld)(a[0] / k) / a[0] * k;
    }
    ld res = 0;

    vector<int> b(n, 1);  // <= a[i]
    int mul_b = 1;  // >= k
    ld mul_ab = 1;

    for (int i = 0; i < n; ++i) {
        if (mul_b * a[i] >= k) {
            b[i] = (k + mul_b - 1) / mul_b;

            if (b[i] * b[i] > a[i]) {
                b[i] = (a[i]) / ((a[i]) / b[i]); 
            }

            mul_b *= b[i];
            mul_ab *= (ld)(a[i] / b[i]) / a[i] * b[i];
        } else {
            b[i] = a[i];
            mul_b *= b[i];
        }
    }

    if (mul_b < k) return 0;
    // assert(mul_b >= k);


    while (!isTimeLimit()) {
        // cerr << "ouuu " << endl;
        int r = rand() % n;
        // while (b[r] == 1) r = rand() % n;

        int r1 = rand() % n;
        while (r1 == r) r1 = rand() % n;
        // while (b[r1] == a[r1]) r1 = rand() % n;

        int sq = (int)(floor(sqrt(a[r1])));
        int s1 = rand() % sq + 1;
        if (rand() % 2) {
            s1 = a[r1] / s1;
        }

        if (s1 > b[r1]) continue;
        if (mul_b / b[r1] * s1 / b[r] * a[r] < k) continue;

        // a[r1] теперь разделен на s1 частей
        int mul_b_new = mul_b / b[r1] * s1 / b[r];
        int s = (k + mul_b_new - 1) / mul_b_new;

        if (s * s > a[r]) {
            s = (a[r]) / ((a[r]) / s); 
        }

        // a[r] теперь разделен на s частей
        
        mul_b_new = mul_b_new * s;

        assert(mul_b_new >= k);

        double mul_ab_new = mul_ab / ((ld)(a[r] / b[r]) / a[r] * b[r]);
        mul_ab_new = mul_ab_new / ((ld)(a[r1] / b[r1]) / a[r1] * b[r1]);
        
        mul_ab_new = mul_ab_new * ((ld)(a[r1] / s1) / a[r1] * s1);
        mul_ab_new = mul_ab_new * ((ld)(a[r] / s) / a[r] * s);

        if (mul_ab_new * k / mul_b_new > res) {
            mul_b = mul_b_new;
            mul_ab = mul_ab_new;
            res = mul_ab_new * k / mul_b_new;
            b[r] = s;
            b[r1] = s1;
        }

    }

    return res;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> k;
    a.resize(n);
    for (int i = 0; i < n; i++) cin >> a[i];

    cout << fixed << setprecision(20);

    cout << solve() << '\n';;
    
    return 0;
}
