#include<bits/stdc++.h>
using namespace std;
#define ll long long
#define pii pair<int, int>
#define ld double
#define all(a) (a).begin(), (a).end()
// #define int long long


int n, k;
vector<int> a;

void read() {
    cin >> n >> k;
    a.resize(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
}


bool isTimeLimit(ld TL) {
    return clock() > TL * CLOCKS_PER_SEC;
}


namespace random_stuff {

double solve(ld TIME_LIMIT) {
    if (k == 1) return 1;
    if (n == 1) {
        return (ld)(a[0] / k) / a[0] * k;
    }

    ld res = 0;

    while (!isTimeLimit(TIME_LIMIT)) {
        random_shuffle(all(a));
        ll parts = 1;
        for (int i = 0; i < n; ++i) {
            if (parts * a[i] >= k) {
                int need = (k + parts - 1) / parts;
                res = max(res, (ld)k / parts * (a[i] / need) / a[i]);
                break;
            } else {
                parts *= a[i];
            }
        }
    }

    return res;
}

}  // namespace random_stuff


signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    read();

    cout << fixed << setprecision(20);

    ld ans_ann = random_stuff::solve(1.96);


    cout << ans_ann << '\n';


    return 0;
}
