#include<bits/stdc++.h>
using namespace std;
#define ll long long
#define pii pair<int, int>
#define ld long double
#define all(a) (a).begin(), (a).end()

const int inf = 1e9 + 7;

const int maxa = 1e4 + 2;

// const int maxk = 1e6 + 2;
const int maxsqk = 4e3;//1e3 + 2;

const int maxn = 1e2 + 2;

int n;
vector<int> a;
int k;

ld dp[maxn][2 * maxsqk];

vector<ld> back_a;

void relax(int i, ll d1, ll d, int ml) {
    if (d1 * d1 >= k) d1 = maxsqk + (k + d1 - 1) / d1;
    if (d * d >= k) d = maxsqk + (k + d - 1) / d;
    if (dp[i][d] * back_a[i] * ml > dp[i + 1][d1]) {
        dp[i + 1][d1] = dp[i][d] * back_a[i] * ml;
    }
}

ld solve() {
    dp[0][1] = 1;

    // forward
    for (int i = 0; i < n; i++) {
        for (int d = 1; d * d <= k; d++) {
            for (int d1 = 1; d1 * d1 <= k; ++d1) {
                int d0 = (k + d - 1) / d;
                int d2 = (k + d1 - 1) / d1;
                if (d1 >= d) relax(i, d1, d, a[i] / ((d1 + d - 1) / d));
                relax(i, d2, d, a[i] / ((d2 + d - 1) / d));
                if (d2 >= d0) relax(i, d2, d0, a[i] / ((d2 + d0 - 1) / d0));
            }
        }
    }

    return dp[n][maxsqk + 1] * k;
}


signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n;
    cin >> k;

    a.resize(n);
    back_a.resize(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    for (int i = 0; i < n; ++i) back_a[i] = (ld)1 / a[i];

    cout << fixed << setprecision(20);
    cout << solve() << '\n';

    return 0;
}
