#include<bits/stdc++.h>
using namespace std;
#define ll long long
#define pii pair<int, int>
#define ld long double
#define all(a) (a).begin(), (a).end()

const int inf = 1e9 + 7;

const int MAXK = 1e7 + 10;
const int MAXSQK = 6500;
const int MAXN = 1e2 + 2;

int n;
vector<int> a;
int k;


int div_in[MAXSQK];
int top = 0;

int pos[MAXK];

void precalc() {
    div_in[top++] = k;
    pos[k] = 0;
    for (int i = 2; i <= k; ++i) {
        if (div_in[top - 1] != (k + i - 1) / i) {
            pos[(k + i - 1) / i] = top;
            div_in[top++] = (k + i - 1) / i;
        }
    }
}

ld dp[MAXN][MAXSQK];

void relax(ld& a, ld b) {
    a = max(a, b);
}


ld solve() {
    dp[0][0] = 1;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < top; ++j) {
            int left = div_in[j];
            // перебираем способы доразбить на разумное кол-во частей
            ld back_ai = (ld)1 / a[i];
            for (int s = 1; s * s <= left; ++s) {
                // разбили на s
                relax(dp[i + 1][pos[(left + s - 1) / s]], dp[i][j] * back_ai * (a[i] / s));
            }
            for (int s = 1; s * s <= left; ++s) {
                // разбили на  (left + s - 1) / s
                relax(dp[i + 1][pos[s]], dp[i][j] * back_ai *  (a[i] / ((left + s - 1) / s)));
            }
        }
        for (int d = top - 2; d >= 0; --d) {
            dp[i + 1][d] = max(dp[i + 1][d], dp[i + 1][d + 1]);
        }
    }
    return dp[n][top - 1] * k;
}


signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> k;
    a.resize(n);
    for (int i = 0; i < n; i++) cin >> a[i];


    precalc();

    solve();

    cout << fixed << setprecision(20);
    
    cout << dp[n][top - 1] * k << '\n';

    return 0;
}
