#include <bits/stdc++.h>

using namespace std;

constexpr int maxx = 500'000;

constexpr long long q = 1'000'000'007;

struct dsu {
	array<int, maxx * 2> p;
	array<int, maxx * 2> sz;

	dsu() {
		p.fill(-1);
		sz.fill(1);
	}

	int pre(int a) {
		if (p[a] == -1) {
			return a;
		}
		return p[a] = pre(p[a]);
	}

	void merge(int a, int b) {
		if (sz[a] < sz[b]) {
			swap(a, b);
		}
		p[b] = a;
		sz[a] += sz[b];
	}
};

dsu h[20];

long long pw(long long a, long long b) {
	if (b == 1) {
		return a;
	}
	if (b % 2 == 0) {
		return pw(a * a % q, b / 2);
	}
	return a * pw(a * a % q, b / 2) % q;
}

int pre[maxx][20];

long long ans = 1;

long long ll[maxx], rr[maxx];

void merg(int a, int b, int l) {
	// cout << a << ' ' << b << ' ' << l << '\n';
	if (l == 0) {
		if (a >= maxx) {
			a -= maxx;
		}
	}
	int aa = h[l].pre(a);
	int bb = h[l].pre(b);
	if (aa == bb) {
		return;
	}
	if (l > 0) {
		h[l].merge(aa, bb);
		l--;
		if (a >= maxx) {
			int pa = pre[a - maxx][l];
			merg(pa + maxx, b, l);
			merg(a, pre[b][l], l);
			return;
		}
		merg(a, b, l);
		merg(pre[a][l], pre[b][l], l);
		return;
	}
	if (ans == 0) {
		return;
	}
	ans = ans * pw(rr[aa] - ll[aa], q - 2) % q;
	ans = ans * pw(rr[bb] - ll[bb], q - 2) % q;
	h[0].merge(aa, bb);

	int c = h[0].pre(aa);
	rr[c] = min(rr[aa], rr[bb]);
	ll[c] = max(ll[aa], ll[bb]);
	if (ll[c] > rr[c]) { // bug forget
		ans = 0;
		return;
	}
	ans *= rr[c] - ll[c];
	ans %= q;
}

int d[maxx];
vector<int> s[maxx];

int tin[maxx], tout[maxx], ttt;

void dfs(int a) {
	if (a > 0) {
		d[a] = d[pre[a][0]] + 1;
	}

	for (int i = 1; i < 20; i++) {
		pre[a][i] = pre[pre[a][i - 1]][i - 1];
	}

	tin[a] = ttt++;

	for (auto i : s[a]) {
		dfs(i);
	}

	tout[a] = ttt++;
}

inline bool is_pre(int a, int b) {
	return tin[a] <= tin[b] && tout[b] <= tout[a];
}

void pth(int la, int ra, int lb, int rb) {
	// cout << la << ' ' << ra << ' ' << lb << ' ' << rb << '\n';
	for (int i = 19; i >= 0; i--) {
		int pa = pre[la][i];
		int pb = pre[lb][i];
		if (is_pre(pa, ra) || is_pre(pb, rb)) {
			continue;
		}
		merg(la, lb, i);
		la = pa;
		lb = pb;
	}

	if (!is_pre(lb, rb)) {
		swap(la, lb);
		swap(ra, rb);
	}

	if (!is_pre(la, ra)) {
		merg(la, lb, 0);
		la = pre[la][0];
		if (!is_pre(lb, rb)) {
			lb = pre[lb][0];
		} else {
			int c = d[lb];
			lb = rb;
			for (int i = 19; i >= 0; i--) {
				if (d[pre[lb][i]] > c) {
					lb = pre[lb][i];
				}
			}
		}
	}

	// cout << la << ' ' << ra << ' ' << lb << ' ' << rb << '\n';

	for (int i = 19; i >= 0; i--) {
		int pa = pre[ra][i];
		int pb = pre[rb][i];
		// cout << i << ' ' << pa << ' ' << pb << '\n';
		if (is_pre(pa, la) || is_pre(pb, lb)) {
			continue;
		}
		merg(ra, rb, i);
		ra = pa;
		rb = pb;
	}

	if (!is_pre(rb, lb)) {
		swap(la, lb);
		swap(ra, rb);
	}

	if (!is_pre(ra, la)) {
		// cout << la << ' ' << ra << ' ' << lb << ' ' << rb << '\n';
		merg(ra, rb, 0);
		ra = pre[ra][0];
		if (!is_pre(rb, lb)) {
			rb = pre[rb][0];
		} else {
			int c = d[rb];
			rb = lb;
			for (int i = 19; i >= 0; i--) {
				if (d[pre[rb][i]] > c) {
					rb = pre[rb][i];
				}
			}
		}
	}

	// cout << la << ' ' << ra << ' ' << lb << ' ' << rb << '\n';

	if (d[la] > d[ra]) {
		swap(la, lb);
		swap(ra, rb);
	}
	// cout << la << ' ' << ra << ' ' << lb << ' ' << rb << '\n';

	int dd = d[ra] - d[la] + 1;

	// cout << dd << '\n';

	array<int, 20> aa;
	for (int i = 0; i < 20; i++) {
		if (dd & (1 << i)) {
			aa[i] = ra;
			ra = pre[ra][i];
		}
	}

	for (int i = 19; i >= 0; i--) {
		if (dd & (1 << i)) {
			merg(aa[i] + maxx, lb, i);
			lb = pre[lb][i];
		}
	}

	// BUG!
	// if (is_pre(la, ra)) {
	// 	swap(la, ra);
	// }

	// if (is_pre(lb, rb)) {
	// 	swap(lb, rb);
	// }

	// int dd = d[ra] - d[la] + 1;

	// for (int i = 19; i >= 0; i--) {
	// 	if (dd & (1 << i)) {
	// 		merg(la, lb, i);
	// 		la = pre[la][i];
	// 		lb = pre[lb][i];
	// 	}
	// }
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	for (int i = 1; i < n; i++) {
		int a;
		cin >> a;
		a--;
		s[a].emplace_back(i);
		pre[i][0] = a;
	}
	for (int i = 0; i < n; i++) {
		cin >> ll[i] >> rr[i];
		rr[i]++;
		ans *= (rr[i] - ll[i]);
		ans %= q;
	}
	dfs(0);
	int m;
	cin >> m;
	for (int i = 0; i < m; i++) {
		int a, b, c, d;
		cin >> a >> b >> c >> d;
		a--; b--; c--; d--;
		pth(a, b, c, d);
		cout << ans << '\n';
	}
}
