#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;

map<string, string> params;

long long get(string name, long long def = 0) {
  if (params.count(name)) {
    return stoll(params[name]);
  } else {
    return def;
  }
}

int main(int argc, char *argv[]) {
  registerGen(argc, argv, 1);
  for (int i = 1; i < argc; i++) {
    string s = string(argv[i]);
    if (s.find("=") != string::npos) {
      auto pos = s.find("=");
      params[s.substr(0, pos)] = s.substr(pos + 1);
    } else {
      params[s] = "";
    }
  }

  int n = get("n");
  int sumK = get("sumK");
  long long maxC = get("maxC");
  int k_i = get("k_i");

  cout << n << "\n";

  for (int i = 0; i < n; ++i) {
    int k = rnd.next(1, min(k_i, sumK - (n - i) + 1));
    sumK -= k;
    cout << k << "\n";
    vector<int> res;
    for (int j = 0; j < k; ++j) {
      int a_j = rnd.next(1, (int)maxC);
      res.emplace_back(a_j);
    }
    sort(res.begin(), res.end());
    for (int j = 0; j < k; ++j) {
      cout << res[j] << ((j != k - 1) ? " " : "");
    }
    cout << '\n';
  }
}
