#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

#define pbc push_back
#define pob pop_back()
#define mp make_pair
#define all(a) (a).begin(), (a).end()
#define vin(a) for (auto& i : a) cin >> i

// mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

template<typename T1, typename T2> 
inline void chkmin(T1& x, const T2& y) {
    if (y < x) x = y;
}

template<typename T1, typename T2>
inline void chkmax(T1& x, const T2& y) {
    if (x < y) x = y;
}

struct SegmentTree{
    int n;
    vector<int> tree;
    SegmentTree() {}
    SegmentTree(int _n) : n(_n), tree(n) {} 
    void upd(int pos, int val) {
        for (; pos < n; pos |= pos + 1) {
            chkmax(tree[pos], val);
        }
    }
    int get(int r) {
        int ans = 0;
        for (; r >= 0; r = (r & (r + 1)) - 1) {
            chkmax(ans, tree[r]);
        }
        return ans;
        // return *max_element(tree.begin(), tree.begin() + r + 1);
    }
};

const int N = 2e5 + 10;
int n;
vector<int> a[N];
SegmentTree st;

int dp[N];

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    cout.precision(20), cout.setf(ios::fixed);
    cin >> n;
    st = SegmentTree(N);
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        int cur = -1;
        for (int j = 0; j < k; ++j) {
            int val;
            cin >> val;
            if (val > cur) {
                a[i].push_back(val);
                cur = val;
            }
        }
    }
    sort(a, a + n, [&] (const vector<int>& lhs, const vector<int>& rhs) {
        return lhs.back() < rhs.back();
    });

    for (int i = 0; i < n; ++i) {
        dp[i] = a[i].size();
        for (int j = 0; j < (int)a[i].size(); ++j) {
            int val = st.get(a[i][j] - 1);
            chkmax(dp[i], val + (int)a[i].size() - j);
        }
        st.upd(a[i].back(), dp[i]);
    }

    cout << *max_element(dp, dp + n) << endl;
    return 0;
}
