#include "bits/stdc++.h"
#include <algorithm>
#include <locale>
#include <random>
#include <unordered_map>
#include <vector>

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
typedef long long ll;
typedef long double db;
typedef unsigned long long ull;

void fast_io() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);
}

vector<int> shrink(vector<int> &a) {
  vector<int> a1;
  int n = a.size();
  int mx = 0;
  for (int i = 0; i < n; ++i) {
    if (a[i] > mx) {
      a1.emplace_back(a[i]);
      mx = a[i];
    }
  }
  return a1;
}

struct ev {
  int x, ind, bal;
  ev() {}
  ev(int x, int ind, int bal) : x(x), ind(ind), bal(bal) {}
};

bool cmp(const ev &a, const ev &b) {
  if (a.x == b.x) {
    return a.bal > b.bal;
  }
  return a.x < b.x;
}

signed main() {
  fast_io();
  int n;
  cin >> n;
  vector<vector<int>> a(n);
  int k;
  for (int i = 0; i < n; ++i) {
    int k;
    cin >> k;
    a[i].resize(k);
    for (auto &j : a[i]) {
      cin >> j;
    }
  }
  vector<vector<int>> a1(n);
  int maxC = 0;
  for (int i = 0; i < n; ++i) {
    a1[i] = shrink(a[i]);
  }

  vector<ev> e(2 * n);
  for (int i = 0; i < n; ++i) {
    e[i * 2] = ev(a1[i].front(), i, 1);
    e[i * 2 + 1] = ev(a1[i].back(), i, -1);
  }

  vector<int> dp(n);
  sort(all(e), cmp);
  int closed = 0;

  int prev = -1;
  int newclosed = 0;

  for (int i = 0; i < 2 * n; ++i) {
    if (prev != e[i].x) {
      prev = e[i].x;
      closed = max(closed, newclosed);
    }
    if (e[i].bal == -1) {
      dp[e[i].ind] =
          max(dp[e[i].ind] + int(a1[e[i].ind].size() - 1), closed + 1);
      newclosed = max(newclosed, dp[e[i].ind]);
    } else {
      dp[e[i].ind] = closed + 1;
    }
  }
  closed = max(closed, newclosed);
  cout << closed;
  return 0;
}
