#include "bits/stdc++.h"
#include <algorithm>
#include <locale>
#include <random>
#include <unordered_map>
#include <vector>

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
typedef long long ll;
typedef long double db;
typedef unsigned long long ull;

void fast_io() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);
}

vector<int> shrink(vector<int> &a) {
  vector<int> a1;
  int n = a.size();
  int mx = 0;
  for (int i = 0; i < n; ++i) {
    if (a[i] > mx) {
      a1.emplace_back(a[i]);
      mx = a[i];
    }
  }
  return a1;
}

bool cmp(const vector<int> &a, const vector<int> &b) {
  return a.back() < b.back();
}

int intersect(vector<int> &a1, vector<int> &a2) {
  int mx = a1.back();
  for (int i = 0; i < a2.size(); ++i) {
    if (a2[i] > mx) {
      return i;
    }
  }
  return a2.size();
}

signed main() {
  fast_io();
  int n;
  cin >> n;
  vector<vector<int>> a(n);
  int k;
  for (int i = 0; i < n; ++i) {
    int k;
    cin >> k;
    a[i].resize(k);
    for (auto &j : a[i]) {
      cin >> j;
    }
  }
  vector<vector<int>> a1(n);
  for (int i = 0; i < n; ++i) {
    a1[i] = shrink(a[i]);
  }
  sort(all(a1), cmp);
  vector<int> dp(n);
  dp[0] = a1[0].size();
  for (int i = 1; i < n; ++i) {
    dp[i] = a1[i].size();
    for (int j = 0; j < i; ++j) {
      int it = a1[i].size() - (intersect(a1[j], a1[i]));
      dp[i] = max(dp[i], dp[j] + it);
    }
  }
  cout << dp[n - 1];
  return 0;
}
