#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;

const int maxxn = 500'000;
const int maxx = 1'000'000;

const int maxn[10] = {maxxn, 100, 100, 5000, 100, maxxn, maxxn, maxxn, maxxn, maxxn};
const int maxm[10] = {maxxn, 100, 500, maxxn, maxxn, maxxn, maxxn, maxxn, maxxn, maxxn};
const int maxt[10] = {maxx, 100, 5000, 5000, 50'000, 100'000, 250'000, 500'000, 750'000, 5'000'000};
const int maxs[10] = {maxx, 10'000, maxx, maxx, maxx, 100'000, 100'000, 100'000, 100'000, maxx};

int main(int argc, char* argv[]) {
	registerValidation(argc, argv);
	int group = atoi(validator.group().c_str());
	if (validator.group() != "") {
		int group = stoi(validator.group());
	}
	int n = inf.readInt(1, maxn[group], "n");
	inf.readSpace();
	int m = inf.readInt(1, maxm[group], "m");
	inf.readEoln();
	auto t = inf.readToken("[a-z]{1," + to_string(maxt[group]) + "}", "t");
	inf.readEoln();
	int slen = 0;
	set<string> ss;
	for (int i = 0; i < n; i++) {
		auto s = inf.readToken("[a-z]{1," + to_string(maxs[group]) + "}", "s");
		inf.readEoln();
		
		slen += s.size();
		ensuref(slen <= maxs[group], "Total strings length exceeds %d", maxs[group]);

		ensuref(!ss.count(s), "%d-th string contains twice", i + 1);
		ss.insert(s);
	}
	for (int i = 0; i < m; i++) {
		int l, r;
		l = inf.readInt(1, t.size(), "l");
		inf.readSpace();
		inf.readInt(l, t.size(), "r");
		inf.readEoln();
	}
	inf.readEof();
}
