#include "testlib.h"

const int MAXN[6] = {500'000, 20, 500, 5'000, 500'000, 500'000};

int main(int argc, char** argv) {
    registerValidation(argc, argv);

    int group = atoi(validator.group().c_str());

    int n = inf.readInt(2, MAXN[group], "n");
    inf.readEoln();

    for (int i = 0; i < n; ++i) {
        int ai = inf.readInt(0, 1'000'000'000, "a_i");
        inf.readSpace();
        int bi = inf.readInt(0, 1'000'000'000, "b_i");
        inf.readEoln();

        if (group == 4) {
            ensuref(ai == bi, "a_i != b_i in group 4");
        }
    }

    inf.readEof();

    return 0;
}