#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <cassert>
#include <deque>
#include <stack>
#include <unordered_map>
#include <random>
#include <unordered_set>

#define int long long
#define all(a) a.begin(), a.end()

using namespace std;

const int INF = 1e9 + 123;

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  cout.tie(NULL);
  
  int n;
  cin >> n;
  vector <pair <int, int>> p(n);
  for (int i = 0; i < n; ++i) {
    cin >> p[i].first >> p[i].second;
  }
  sort(all(p));

  vector <int> suf(n);
  suf[n - 1] = p[n - 1].second;
  for (int i = n - 2; i >= 0; --i) {
    suf[i] = max(suf[i + 1], p[i].second);
  }

  set <int> have;
  set <int> anti_have;

  int ans = INF;
  for (int i = 0; i < n; ++i) {
    int cur_a = p[i].first;
    int cur_b = p[i].second;

    int down_b = (i == n - 1 ? 0 : suf[i + 1]);
    
    int max_b = down_b;

    if (max_b >= cur_a) {
      ans = min(ans, max_b - cur_a);
    } else {
      auto it = have.lower_bound(cur_a);
      if (it != have.end()) {
        int one = *it;
        ans = min(ans, abs(cur_a - one));
      }
      auto it2 = anti_have.lower_bound(-cur_a);
      if (it2 != anti_have.end()) {
        int two = -(*it2);
        ans = min(ans, abs(cur_a - two));
      }
      ans = min(ans, abs(cur_a - max_b));
      //cout << i << endl;
    }
    //cout << ans << endl;
    have.insert(cur_b);
    anti_have.insert(-cur_b);
  }
  cout << ans;
  /*

  int ans = 1e9 + 123;
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < n; ++j) {
      if (i == j) {
        continue;
      }
      ans = min(ans, abs(a[i] - b[j]));
      ans = min(ans, abs(a[j] - b[i]));
    }
  }

  cout << ans;*/
}
/*
5
1 5
2 7
3 3
4 10
2 5
*/