#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

ll GetSegmentSum(int L, int R) {
    return (ll)(R - L + 1) * (ll)(L + R) / 2LL;
}

map<int, ll> cache;

ll Ask(int p) {
    if (cache.find(p) != cache.end()) {
        return cache[p];
    }
    cout << "? " << p << endl;
    ll ans;
    cin >> ans;
    if (ans == -1) {
        exit(0);
    }
    ans = GetSegmentSum(1, p) - ans;
    cache[p] = ans;
    return ans;
}

void Answer(const vector<int>& p) {
    cout << "! ";
    for (int i : p) {
        cout << i << " ";
    }
    cout << endl;
    int ans;
    cin >> ans;
    if (ans == -1) {
        exit(0);
    }
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> ans;
    int last = 0;
    ll last_sum = 0;
    for (int it = 0; it < k; it++) {
        int L = last + 1;
        int R = n + 1;
        while (R - L > 1) {
            int h = (L + R) / 2;
            if (Ask(h - 1) == last_sum) {
                L = h;
            } else {
                R = h;
            }
        }
        ans.emplace_back(L);
        last = L;
        last_sum = Ask(L);
    }
    Answer(ans);
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int t;
    cin >> t;
    while (t--) {
        cache.clear();
        solve();
    }

    return 0;
}
