#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

ll GetSegmentSum(int L, int R) {
    return (ll)(R - L + 1) * (ll)(L + R) / 2LL;
}

map<int, ll> cache;

ll Ask(int p) {
    if (cache.find(p) != cache.end()) {
        return cache[p];
    }
    cout << "? " << p << endl;
    ll ans;
    cin >> ans;
    if (ans == -1) {
        exit(0);
    }
    ans = GetSegmentSum(1, p) - ans;
    cache[p] = ans;
    return ans;
}

void Answer(const vector<int>& p) {
    cout << "! ";
    for (int i : p) {
        cout << i << " ";
    }
    cout << endl;
    int ans;
    cin >> ans;
    if (ans == -1) {
        exit(0);
    }
}

vector<int> ans;

void solve(int l, int r, ll sl, ll sr) {
    ll s = sr - sl;
    if (s == 0) {
        return;
    }
    if (l <= s && s <= r) {
        ans.emplace_back(s);
        return;
    }
    int mid = 2LL * (ll)l * (ll)r / (l + r);
    ll s_mid = Ask(mid);
    solve(l, mid, sl, s_mid);
    solve(mid + 1, r, s_mid, sr);
}

void solve() {
    int n, k;
    cin >> n >> k;
    ans.clear();
    vector<pair<int, ll>> pos;
    pos.emplace_back(0, 0LL);
    for (int i = 1; (1 << i) <= n; i++) {
        pos.emplace_back((1 << i) - 1, Ask((1 << i) - 1));
    }
    pos.emplace_back(n, Ask(n));
    for (int i = 1; i < (int)pos.size(); i++) {
        solve(pos[i - 1].first + 1, pos[i].first, pos[i - 1].second, pos[i].second);
    }
    Answer(ans);
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int t;
    cin >> t;
    while (t--) {
        cache.clear();
        solve();
    }

    return 0;
}
