#include<bits/stdc++.h>
using namespace std;
#define ll long long
#define pii pair<int, int>
#define ld double
#define all(a) (a).begin(), (a).end()

const int inf = 1e9 + 7;

const int maxa = 1e4 + 2;

// const int maxk = 1e6 + 2;
const int maxsqk = 4e3;//1e3 + 2;

const int maxn = 1e2 + 2;

int n;
vector<int> a;
int k;

ld dp[maxn][2 * maxsqk];

vector<ld> back_a;

void relax(int i, ll d1, ll d, int ml) {
    if (d1 * d1 >= k) d1 = maxsqk + (k + d1 - 1) / d1;
    if (d * d >= k) d = maxsqk + (k + d - 1) / d;
    dp[i + 1][d1] = max(dp[i + 1][d1], dp[i][d] * back_a[i] * ml);
}


int ai_div_d1[maxn][maxsqk];
void precalc() {
    for (int i = 0; i < n; ++i) {
        for (int d1 = 1; d1 * d1 <= k; ++d1) {
            ai_div_d1[i][d1] = a[i] / d1;
        }
    }
}

ld solve() {
    dp[0][1] = 1;

    // forward
    for (int i = 0; i < n; i++) {
        for (int d = 1; d * d <= k; d++) {
            int d0 = (k + d - 1) / d;
            // divided in d parts
            for (int d1 = 1; d1 * d1 <= d0; ++d1) {
                relax(i, d * d1, d, a[i] / d1);//ai_div_d1[i][d1]);
                int divin = (d0 + d1 - 1) / d1;
                relax(i, d * divin, d, a[i] / divin);
            }
            for (int d1 = 1; d1 * d1 <= d; ++d1) {
                relax(i, d0 * d1, d0, a[i] / d1);//ai_div_d1[i][d1]);
                int divin = (d + d1 - 1) / d1;
                relax(i, d0 * divin, d0, a[i] / divin);
            }
        }
        if (k > 4) {
            for (int d = 2; d * d <= k; ++d) {
                dp[i + 1][maxsqk + d] = max(dp[i + 1][maxsqk + d], dp[i + 1][maxsqk + d - 1]);
            }
            int dd = floor(sqrt(k) + 1e-8);
            dp[i + 1][dd] = max(dp[i + 1][dd], dp[i + 1][maxsqk + dd]);
            for (int d = dd - 1; d >= 1; --d) {
                dp[i + 1][d] = max(dp[i + 1][d], dp[i + 1][d + 1]);    
            }    
        }
    }

    return dp[n][maxsqk + 1] * k;
}


signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n;
    cin >> k;

    a.resize(n);
    back_a.resize(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    for (int i = 0; i < n; ++i) back_a[i] = (ld)1 / a[i];

    // precalc();

    cout << fixed << setprecision(20);
    cout << solve() << '\n';

    return 0;
}
