#include<bits/stdc++.h>
using namespace std;
#define ll long long
#define pii pair<int, int>
#define ld long double
#define all(a) (a).begin(), (a).end()

const int inf = 1e9 + 7;

int n;
vector<int> a;
int k;

vector<vector<ld>> dp;

void relax(ld& a, ld b) {
    a = max(a, b);
}

ld solve() {
    dp.resize(n + 1, vector<ld>(k + 1, 0));
    
    dp[0][1] = 1;

    for (int i = 0; i < n; ++i) {
        for (int j = 1; j <= k; ++j) {
            for (int m = 1; (m - 1) * j < k; ++m) {
                relax(dp[i+1][min(k, m * j)], dp[i][j] / a[i] * (a[i] / m));
            }
        }
    }

    return dp[n][k] * k;
}


signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> k;
    a.resize(n);
    for (int i = 0; i < n; i++) cin >> a[i];

    solve();

    cout << fixed << setprecision(20);
    
    cout << dp[n][k] * k << '\n';

    return 0;
}
