#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

#define pbc push_back
#define pob pop_back()
#define mp make_pair
#define all(a) (a).begin(), (a).end()
#define vin(a) for (auto& i : a) cin >> i

// mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

template<typename T1, typename T2> 
inline void chkmin(T1& x, const T2& y) {
    if (y < x) x = y;
}

template<typename T1, typename T2>
inline void chkmax(T1& x, const T2& y) {
    if (x < y) x = y;
}
const int MAXN  =3002;
vector<int> g[MAXN];
const int mod = 1000000007;
int p[MAXN];
const int inf  =1e9;
int rnk[MAXN];
pair<int,int> seg[MAXN];
int n;
int mul(int a,int b)
{
    return 1ll * a * b % mod;
}
vector<int> getp(int a, int b)
{
    vector<int> d(n+1, inf);
    d[a] = 0;
    queue<int> q;
    q.push(a);
    vector<int> par(n+1);
    while(q.size())
    {
        int v=q.front();
        q.pop();
        for(int i:g[v])
        {
            if(d[i] > d[v] + 1)
            {
                d[i] = d[v] + 1;
                par[i]= v;
                q.push(i);
            }
        }
    }
    vector<int> res;
    while(b!=a)
    {
        res.pbc(b);
        b=  par[b];
    }
    res.pbc(a);
    return res;
}
void make(int v)
{
    p[v]=v;
    rnk[v]= 0;
}
int fin(int v)
{
    return v==p[v] ? v :p[v]=fin(p[v]);
}
pair<int,int> inter(pair<int, int> a,pair<int,int> b)
{
    return {max(a.first,b.first), min(a.second, b.second)};
}
void unite(int a, int b)
{
    a=fin(a), b=fin(b);
    if(a==b) return;
    if(rnk[a] < rnk[b]) swap(a,b);
    p[b] = a;
    seg[a] = inter(seg[a], seg[b]);
    rnk[a] += (rnk[a] == rnk[b]);
}
signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    cout.precision(20), cout.setf(ios::fixed);
    cin>>n;
    for(int i =2;i<=n;++i)
    {
        int x;
        cin>>x;
        g[i].pbc(x);
        g[x].pbc(i);
    }
    for(int i=1;i<=n;++i)
    {
        cin>>seg[i].first>>seg[i].second;
        make(i);
    }
    int m;
    cin>>m;
    for(int tt=0;tt< m;++tt)
    {
        int a,b,c,d;
        cin>>a>>b>>c>>d;
        auto fs= getp(a,b), ss= getp(c, d);
        for(int i= 0; i< (int)fs.size();++i) unite(fs[i], ss[i]);
        vector<int> up(n+1);
        int ans=1;
        for(int i=1;i<=n;++i)
        {
            int x=fin(i);
            if(up[x]) continue;
            up[x] =1;
            if(seg[x].second < seg[x].first)
            {
                ans=0;
                break;
            }
            ans=mul(ans, seg[x].second -seg[x].first+1);
        }
        cout<<ans<<'\n';
    }
    return 0;
}
