#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>

using namespace std;

#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define pb emplace_back
#define ll long long

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> w(m);
    int total = 0;
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        w[i] = c;
        total ^= c;
    }
    int path = 0;
    int s, t;
    cin >> s >> t;
    s--; t--;
    for (int i = s; i != t; i = (i + 1) % n) {
        path ^= w[i];
    }
    if (total == 0 && path == 0) {
        cout << 0 << "\n";
    } else {
        cout << -1 << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
