#include "bits/stdc++.h"
#include <algorithm>
#include <locale>
#include <random>
#include <unordered_map>
#include <vector>

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
typedef long long ll;
typedef long double db;
typedef unsigned long long ull;

void fast_io() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);
}

vector<int> shrink(vector<int> &a) {
  vector<int> a1;
  int n = a.size();
  int mx = 0;
  for (int i = 0; i < n; ++i) {
    if (a[i] > mx) {
      a1.emplace_back(a[i]);
      mx = a[i];
    }
  }
  return a1;
}

struct ev {
  int x, ind, bal;
  ev() {}
  ev(int x, int ind, int bal) : x(x), ind(ind), bal(bal) {}
};

bool cmp(const ev &a, const ev &b) {
  if (a.x == b.x) {
    return a.bal < b.bal;
  }
  return a.x < b.x;
}

signed main() {
  fast_io();
  int n;
  cin >> n;
  vector<vector<int>> a(n);
  int k;
  for (int i = 0; i < n; ++i) {
    int k;
    cin >> k;
    a[i].resize(k);
    for (auto &j : a[i]) {
      cin >> j;
    }
  }
  vector<vector<int>> a1(n);
  for (int i = 0; i < n; ++i) {
    a1[i] = shrink(a[i]);
  }

  int one = 0, second = 0;

  for (int i = 0; i < n; ++i) {
    if (a1[i].size() == 2) {
      cout << 2;
      return 0;
    }
    if (a1[i].back() == 1) {
      one = 1;
    }
    if (a1[i].back() == 2) {
      second = 1;
    }
  }
  cout << one + second;

  return 0;
}
