#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

typedef long long ll;

ll GetSegmentSum(int L, int R) {
    return (ll)(R - L + 1) * (ll)(L + R) / 2LL;
}

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);

    int t = opt<int>("t");
    int n = opt<int>("n");
    int k = opt<int>("k");
    int w = (has_opt("w") ? opt<int>("w") : 0);
    
    if (has_opt("q")) {
        println(opt<int>("q"), opt<int>("q"));
    } else {
        println(-1, 3500);
    }

    println(t);
    for (int i = 0; i < t; i++) {
        println("adaptive");

        int cur_n = n;
        if (cur_n < 0) {
            cur_n = rnd.next(1, -cur_n);
        }

        int cur_k = k;
        if (cur_k < 0) {
            cur_k = rnd.next(1, min(cur_n, -cur_k));
        }
        if (cur_k > cur_n) {
            cur_k = cur_n;
        }

        int cur_w = rnd.next(-w, w);

        ll s = rnd.wnext(GetSegmentSum(1, cur_k), GetSegmentSum(cur_n - cur_k + 1, cur_n), cur_w);
        println(cur_n, cur_k, s);
    }

    return 0;
}
