#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

std::vector<int> RandSet(int n, int k, int w) {
    if (w == 0) {
        auto res = rnd.distinct(k, 1, n);
        sort(res.begin(), res.end());
        return res;
    }
    std::vector<int> ans;
    for (int i = 0; i < k; i++) {
        ans.push_back(rnd.wnext(n - k + 1, w));
    }
    std::sort(ans.begin(), ans.end());
    for (int i = 0; i < k; i++) {
        ans[i] += i + 1;
    }
    return ans;
}

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);

    int t = opt<int>("t");
    int n = opt<int>("n");
    int k = opt<int>("k");
    int w = (has_opt("w") ? opt<int>("w") : 0);
    
    if (has_opt("q")) {
        println(opt<int>("q"), opt<int>("q"));
    } else {
        println(-1, 3500);
    }

    println(t);
    for (int i = 0; i < t; i++) {
        println("set");

        int cur_n = n;
        if (cur_n < 0) {
            cur_n = rnd.next(1, -cur_n);
        }

        int cur_k = k;
        if (cur_k < 0) {
            cur_k = rnd.next(1, min(cur_n, -cur_k));
        }
        if (cur_k > cur_n) {
            cur_k = cur_n;
        }

        int cur_w = rnd.next(-w, w);

        println(cur_n, cur_k);

        int L = rnd.wnext(cur_n - cur_k + 1, cur_w);
        vector<int> res(cur_k);
        iota(res.begin(), res.end(), L + 1);
        println(res);
    }

    return 0;
}
