#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

ll GetSegmentSum(int L, int R) {
    return (ll)(R - L + 1) * (ll)(L + R) / 2LL;
}

map<int, ll> cache;

ll Ask(int p) {
    if (cache.find(p) != cache.end()) {
        return cache[p];
    }
    cout << "? " << p << endl;
    ll ans;
    cin >> ans;
    if (ans == -1) {
        exit(0);
    }
    ans = GetSegmentSum(1, p) - ans;
    cache[p] = ans;
    return ans;
}

void Answer(const vector<int>& p) {
    cout << "! ";
    for (int i : p) {
        cout << i << " ";
    }
    cout << endl;
    int ans;
    cin >> ans;
    if (ans == -1) {
        exit(0);
    }
}

vector<int> ans;

void solve(int l, int r, ll sl, ll sr) {
    ll s = sr - sl;
    if (s == 0) {
        return;
    }
    if (l <= s && s <= 2 * l) {
        ans.emplace_back(s);
        return;
    }
    int mid = 2LL * (ll)l * (ll)r / (l + r);
    ll s_mid = Ask(mid);
    solve(l, mid, sl, s_mid);
    solve(mid + 1, r, s_mid, sr);
}

void solve() {
    int n, k;
    cin >> n >> k;
    ans.clear();
    solve(1, n, 0, Ask(n));
    Answer(ans);
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int t;
    cin >> t;
    while (t--) {
        cache.clear();
        solve();
    }

    return 0;
}
