#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

ll GetSegmentSum(int L, int R) {
    return (ll)(R - L + 1) * (ll)(L + R) / 2LL;
}

map<int, ll> cache;

ll Ask(int p) {
    if (cache.find(p) != cache.end()) {
        return cache[p];
    }
    cout << "? " << p << endl;
    ll ans;
    cin >> ans;
    if (ans == -1) {
        exit(0);
    }
    ans = GetSegmentSum(1, p) - ans;
    cache[p] = ans;
    return ans;
}

void Answer(const vector<int>& p) {
    cout << "! ";
    for (int i : p) {
        cout << i << " ";
    }
    cout << endl;
    int ans;
    cin >> ans;
    if (ans == -1) {
        exit(0);
    }
}

vector<int> ans;

void solve(int k, int l, int r, ll sl, ll sr) {
    ll s = sr - sl;
    if (s == 0) {
        return;
    }
    if (l <= s && s <= 2 * l) {
        ans.emplace_back(s);
        return;
    }
    int cnt_l = (int)((s + r - 1) / r);
    int cnt_r = (int)min((ll)k, (s / l));
    cnt_r = min(cnt_r, (r - l + 1));
    while (true) {
        if (cnt_r == 1) {
            ans.emplace_back(s);
            return;
        }
        int cnt_mid = (cnt_l + cnt_r + 1) / 2;
        int cur_x = (s / cnt_mid);
        if (cur_x < l) {
            cnt_r = cnt_mid - 1;
            continue;
        } else if (cur_x > r) {
            cnt_l = cnt_mid + 1;
            continue;
        }
        ll s_mid = Ask(cur_x);
        if (s_mid != sl && s_mid != sr) {
            solve(k, l, cur_x, sl, s_mid);
            solve(k, cur_x + 1, r, s_mid, sr);
            return;
        }
        if (s_mid == sl) {
            cnt_r = cnt_mid - 1;
        } else {
            cnt_l = cnt_mid + 1;
        }
    }
}

void solve() {
    int n, k;
    cin >> n >> k;
    ans.clear();
    solve(k, 1, n, 0, Ask(n));
    Answer(ans);
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int t;
    cin >> t;
    while (t--) {
        cache.clear();
        solve();
    }

    return 0;
}
