#include "bits/stdc++.h"

#define rep(i, n) for (int i = 0; i < (n); ++i)
#define rep1(i, n) for (int i = 1; i < (n); ++i)
#define rep1n(i, n) for (int i = 1; i <= (n); ++i)
#define repr(i, n) for (int i = (n) - 1; i >= 0; --i)
#define pb push_back
#define eb emplace_back
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define each(x, a) for (auto &x : a)
#define ar array
#define vec vector
#define range(i, n) rep(i, n)

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using str = string;
using pi = pair<int, int>;
using pl = pair<ll, ll>;

using vi = vector<int>;
using vl = vector<ll>;
using vpi = vector<pair<int, int>>;
using vvi = vector<vi>;

int Bit(int mask, int b) { return (mask >> b) & 1; }

template<class T>
bool ckmin(T &a, const T &b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<class T>
bool ckmax(T &a, const T &b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

const int INFi = 1e9;
const ll INF = 2e18;
const int LG = 20;
const int maxN = 3e5 + 10;
const int md = 1e9 + 7;

void solve() {
    int n, m, p, group;
    cin >> n >> m >> p >> group;
    vector g(n, vl(n, INF));
    vi w(n);
    rep(i, n) g[i][i] = 0;
    rep(i, n) cin >> w[i];
    rep(i, m) {
        int a, b, s;
        cin >> a >> b >> s;
        a--;
        b--;
        g[a][b] = min(g[a][b], 1ll * s);
    }
    rep(k, n) rep(i, n) rep(j, n) g[i][j] = min(g[i][j], g[i][k] + g[k][j]);
    vi perm(n - 2);
    iota(all(perm), 1);
    ll ans = INF;
    if (g[0][n - 1] != INF) ans = min(ans, max(0ll, (g[0][n - 1] - p + w[0] - 1) / w[0]));
    do {
        ll cur = p;
        ll res = 0;
        ll mw = w[0];
        int v = 0;
        for(auto &u : perm) {
            if (g[v][u] == INF) {
                res = INF;
                break;
            }
            ll tmp = max(0ll, (g[v][u] - cur + mw - 1) / mw);
            res += tmp;
            cur += tmp * mw - g[v][u];
            v = u;
            mw = max(mw, 1ll * w[v]);
            if (g[v][n - 1] != INF) ans = min(ans, res + max(0ll, (g[v][n - 1] - cur + mw - 1) / mw));
        }
    } while (next_permutation(all(perm)));
    cout << (ans == INF ? -1 : ans) << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
//    cout << setprecision(15) << fixed;
    int t = 1;
//    cin >> t;
    rep(_, t) {
        solve();
    }
    return 0;
}
