#pragma GCC target("avx2")
#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")

#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <tuple>
#include <math.h>
#include <set>
#include <stack>
#include <bitset>
#include <map>
#include <queue>
#include <random>
#include <array>
#include <unordered_set>
#include <cmath>
#include <cassert>
#include <unordered_map>

#define DEBUG
#define pqueue priority_queue
#define pb(x) push_back(x)
#define endl '\n'
#define all(x) x.begin(), x.end()
#define int long long
#define mk(a, b) make_pair(a, b)

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef vector<int> vi;
typedef vector<vector<int> > vvi;
typedef vector<ull> vull;
typedef vector<ll> vll;
typedef pair<int, int> pii;
typedef vector<pair<int, int> > vpii;
typedef pair<ll, ll> pll;
typedef vector<bool> vb;
typedef vector<string> vs;
typedef vector<vector<int> > vvi;
typedef vector<char> vc;

const ll inf = 1e9 + 228;
const ll infll = 1e18;
const int mod = 1e9 + 7;
const ll mod3 = 1e9 + 7;
const ld eps = 1e-7;
const ll mod2 = 1e9 + 9;
const ld PI = atan2l(0, -1);

void fast_io() {
    srand(time(NULL));
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int edges[100][100];

void solve() {
    int n, m, s, g;
    cin >> n >> m >> s >> g;
    vector<int> w(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            edges[i][j] = infll;
        }
    }
    for (int i = 0; i < n; i++) {
        cin >> w[i];
    }
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--, b--;
        edges[a][b] = min(edges[a][b], c);
    }

    vi ord(n);

    iota(ord.begin(), ord.end(), 0);

    int ans = infll;

    do {
        if (ord[0] != 0)
            break;
        int mx = 0;
        int cur = 0;
        int cur_w = s;
        for (int i = 1; i < n; i++) {
            if (edges[ord[i - 1]][ord[i]] == infll) {
                cur = infll;
                break;
            }
            if (cur_w < edges[ord[i - 1]][ord[i]]) {
                int need = (edges[ord[i - 1]][ord[i]] - cur_w + w[mx] - 1) / w[mx];
                cur += need;
                cur_w += need * w[mx];
            }
            cur_w -= edges[ord[i - 1]][ord[i]];
            if (w[ord[i]] > w[mx])
                mx = ord[i];
            if (ord[i] == n - 1)
                break;
        }
        ans = min(ans, cur);
    } while (next_permutation(all(ord)));

    cout << (ans == infll ? -1 : ans ) << endl;
}

signed main() {
    fast_io();
    int q = 1;
//    cin >> q;
    while (q--)
        solve();
    return 0;
}
